<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <title>JSDoc: Home</title>

    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css" />
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css" />
  </head>

  <body>
    <div id="main">
      <h1 class="page-title">Home</h1>

      <h3></h3>

      <section>
        <article>
          <h1>⚡️ Awesome LWC Collection</h1>
          <p>
            <img src="https://img.shields.io:/github/license/svierk/awesome-lwc-collection" alt="GitHub" />
            <img
              src="https://github.com/svierk/awesome-lwc-collection/actions/workflows/ci.yaml/badge.svg"
              alt="GitHub CI"
            />
            <a href="https://sonarcloud.io/summary/new_code?id=svierk_awesome-lwc-collection"
              ><img
                src="https://sonarcloud.io/api/project_badges/measure?project=svierk_awesome-lwc-collection&amp;metric=alert_status"
                alt="Quality Gate Status"
            /></a>
          </p>
          <h2>About the project</h2>
          <p>
            The repository should provide a collection of ready-to-use Lightning Web Components that might help your
            SFDX project and is intended to grow over time. Additionally, it also includes an initial configuration of
            Prettier, linting rules, git hooks and unit tests as well as useful VS Code settings. The setup really
            focuses on LWC development.
          </p>
          <h2>Prerequisites</h2>
          <p>
            To use this library and try out the components locally, <a href="https://nodejs.org/en/">Node</a> and the
            <a href="https://developer.salesforce.com/tools/sfdxcli">Salesforce CLI</a> should already be installed.
          </p>
          <h2>Getting started</h2>
          <h3>Install all dependencies</h3>
          <p>
            To get the components up and runnning, you need to open the repository with VS Code, install all the
            recommended extensions and run <code>npm install</code> to install all required dependencies.
          </p>
          <h3>Authorize an org</h3>
          <p>
            You need to authorize an org before you use the local development server. This is necessary because all data
            requests using Lightning Data Service or Apex will get proxied to the Salesforce org and returned in the
            local components. In VS Code the authorization can be done by pressing <strong>Command + Shift + P</strong>,
            enter &quot;sfdx&quot;, and select <strong>SFDX: Authorize an Org</strong>.
          </p>
          <p>Alternatively you can also run the following command from the command line:</p>
          <pre class="prettyprint source"><code>sfdx force:auth:web:login
</code></pre>
          <h3>Install the local development server</h3>
          <p>
            Lightning Web Components can be viewed and developed locally without the need to push them to an org first.
            To set up local development you only nedd to install the development server after you authorized an org.
          </p>
          <p>
            The local development server and its configuration are provided by a Salesforce CLI plugin that can be
            installed as follows:
          </p>
          <pre class="prettyprint source"><code>sfdx plugins:install @salesforce/lwc-dev-server
</code></pre>
          <p>
            Run <code>npm run server:lwc</code> to start the server on http://localhost:3333 and access all components
            of this project.
          </p>
          <h2>Components available</h2>
          <p>
            The following list of components is part of this repo. All components contain corresponding unit tests and
            docs.
          </p>
          <ul>
            <li>
              <a
                href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/base64ToPdf"
                >Base64 To PDF</a
              >
            </li>
            <li>
              <a
                href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/csvToDatatable"
                >CSV To Datatable</a
              >
            </li>
            <li>
              <a
                href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/customDatatable"
                >Custom Datatable</a
              >
            </li>
            <li>
              <a
                href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/customMapView"
                >Custom Map View</a
              >
            </li>
            <li>
              <a
                href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/customSlider"
                >Custom Slider</a
              >
            </li>
            <li>
              <a href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/helloWorld"
                >Hello World</a
              >
            </li>
            <li>
              <a href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/iFrame"
                >iFrame</a
              >
            </li>
            <li>
              <a
                href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/localDevelopmentWrapper"
                >Local Development Wrapper</a
              >
            </li>
            <li>
              <a
                href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/multiSelectCombobox"
                >Multi Select Combobox</a
              >
            </li>
            <li>
              <a
                href="https://github.com/svierk/awesome-lwc-collection/tree/main/force-app/main/default/lwc/openRecordPageFlowAction"
                >Open Record Page Flow Action</a
              >
            </li>
          </ul>
          <p>
            You can also find many more useful and reusable Lightning Web Components in the official
            <a href="https://github.com/trailheadapps/lwc-recipes">lwc-recipes</a>.
          </p>
          <h2>Quality measures</h2>
          <h3>Git hooks</h3>
          <p>
            The project includes client-side pre-commit git hooks using
            <a href="https://github.com/typicode/husky">husky</a> and
            <a href="https://github.com/okonet/lint-staged">lint-staged</a>. After installing all project dependencies,
            Prettier, Linter and unit tests are automatically executed before each commit.
          </p>
          <h3>Prettier for code formatting</h3>
          <p>Run <code>npm run prettier</code> to check all files for <em>Prettier</em> issues.</p>
          <h3>Code linting with ESLint</h3>
          <p>Run <code>npm run lint</code> to check for <em>ESLint</em> issues.</p>
          <h3>Unit tests with Jest</h3>
          <p>Run</p>
          <ul>
            <li><code>npm run test:unit</code> to execute all unit tests only once</li>
            <li><code>npm run test:unit:watch</code> to execute all unit tests in watch mode for development</li>
            <li><code>npm run test:unit:coverage</code> to execute all unit tests with generated code coverage</li>
          </ul>
          <h3>Documentation with JSDoc</h3>
          <p>Run <code>npm run docs</code> to generate code documentation with <em>JSDoc</em> in HTML format.</p>
        </article>
      </section>
    </div>

    <nav>
      <h2><a href="index.html">Home</a></h2>
      <h3>Classes</h3>
      <ul>
        <li><a href="Base64ToPdf.html">Base64ToPdf</a></li>
        <li><a href="CsvToDatatable.html">CsvToDatatable</a></li>
        <li><a href="CustomDatatable.html">CustomDatatable</a></li>
        <li><a href="CustomMapView.html">CustomMapView</a></li>
        <li><a href="CustomSlider.html">CustomSlider</a></li>
        <li><a href="HelloWorld.html">HelloWorld</a></li>
        <li><a href="IFrame.html">IFrame</a></li>
        <li><a href="LocalDevelopmentWrapper.html">LocalDevelopmentWrapper</a></li>
        <li><a href="MultiSelectCombobox.html">MultiSelectCombobox</a></li>
        <li><a href="MultiSelectComboboxItem.html">MultiSelectComboboxItem</a></li>
        <li><a href="OpenRecordPageFlowAction.html">OpenRecordPageFlowAction</a></li>
      </ul>
      <h3>Global</h3>
      <ul>
        <li><a href="global.html#slidesData">slidesData</a></li>
      </ul>
    </nav>

    <br class="clear" />

    <footer>
      Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 4.0.0</a> on Thu Feb 16 2023 11:49:13
      GMT+0100 (Central European Standard Time)
    </footer>

    <script>
      prettyPrint();
    </script>
    <script src="scripts/linenumber.js"></script>
  </body>
</html>
